"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.guard = guard;

var _sdk = require("@mightyminds/sdk");

var _utils = require("../utils");

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

var log = require('debug')('mm-vue:auth:guard-current-user');

function guard(router, opts) {
  log("Resitered Vue-Router (beforeEach) current user guard. activated using meta: 'requiresCurrentUser'. params.accountId must be the currentUser");
  router.beforeEach(
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(to, from, next) {
      var config, user;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              config = (0, _utils.findConfig)(to.matched, ['requiresCurrentUser']);

              if (config) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return", next());

            case 3:
              _context.prev = 3;
              _context.next = 6;
              return _sdk.core.auth().currentUserPromise();

            case 6:
              user = _context.sent;
              next(user && user.id === to.params.accountId ? true : new Error("Must be the current user @ ".concat(to.fullPath)));
              _context.next = 13;
              break;

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](3);
              next(_context.t0);

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[3, 10]]);
    }));

    return function (_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }());
}