"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.guard = guard;

var _lodash = _interopRequireDefault(require("lodash"));

var _sdk = require("@mightyminds/sdk");

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var log = require('debug')('mm-vue:auth:guard-rerouter');

function guard(router, opts) {
  log("Resitered Vue-Router (afterEach) rerouter guard. activated using meta: 'onLogin', 'onLogout'. reroute on auth state change");
  var META_SUB = 'meta::sub';
  router.afterEach(function (to) {
    if (_sdk.core.auth()[META_SUB]) _sdk.core.auth()[META_SUB].unsubscribe();
    var config = (0, _utils.findConfig)(to.matched, ['onLogin', 'onLogout']);
    if (!config) return;
    _sdk.core.auth()[META_SUB] = (0, _rxjs.from)(_sdk.core.auth().currentUser$).pipe((0, _operators.distinctUntilChanged)()).subscribe(function (user) {
      var onLogin = config.onLogin,
          onLogout = config.onLogout;

      if (user && onLogin) {
        if (_lodash.default.isFunction(onLogin)) return onLogin();
        router.replace(onLogin);
      }

      if (!user && onLogout) {
        if (_lodash.default.isFunction(onLogout)) return onLogout();
        router.replace(onLogout);
      }
    });
  });
}