"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.install = install;
exports.default = void 0;

var _store = require("./store");

var _context = require("./context.mixin");

var _guard = require("./guard");

function install(Vue, opts) {
  if (install.installed) return;
  install.installed = true;

  var _ref = opts || {},
      store = _ref.store,
      router = _ref.router;

  if (store) (0, _store.sync)(store, opts);
  if (store) Vue.mixin(_context.context);
  if (router) (0, _guard.guard)(router, opts);
}

var _default = install;
exports.default = _default;