"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sync = sync;
exports.NAMESPACE = void 0;

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _sdk = require("@mightyminds/sdk");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var NAMESPACE = 'auth';
exports.NAMESPACE = NAMESPACE;
var CHANGE_CURRENT_USER = 'CHANGE_CURRENT_USER';

var log = require('debug')('mm-vue:auth');

function sync(store, opts) {
  store.registerModule(NAMESPACE, {
    namespaced: true,
    state: function state() {
      return {
        currentUser: null
      };
    },
    mutations: _defineProperty({}, CHANGE_CURRENT_USER, function (state, currentUser) {
      state.currentUser = currentUser;
    })
  });
  (0, _rxjs.from)(_sdk.core.auth().currentUser$).pipe((0, _operators.distinctUntilChanged)()).subscribe(function (currentUser) {
    return store.commit("".concat(NAMESPACE, "/").concat(CHANGE_CURRENT_USER), currentUser);
  });
  log("Registered Vuex module '".concat(NAMESPACE));
}